unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Clipbrd;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure SaveFile(const ClipboardFormat, FileName: String);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.SaveFile(const ClipboardFormat, FileName: String);
var Stream: TFileStream;
    cf: Cardinal;
    mem: Cardinal;
    ptr: Pointer;
    Size: Integer;
begin
  cf := RegisterClipboardFormat(PChar(ClipboardFormat));
  if not Clipboard.HasFormat(cf) then begin
    Application.MessageBox(PChar('Clipboard does not contain '+ClipboardFormat), nil,
      MB_OK or MB_ICONSTOP);
    exit;
  end;
  Clipboard.Open;
  Stream := TFileStream.Create(FileName, fmCreate);
  try
    mem := Clipboard.GetAsHandle(cf);
    Size := GlobalSize(mem);
    ptr := GlobalLock(mem);
    Stream.WriteBuffer(ptr^, Size);
    GlobalUnlock(mem);
  finally
    Stream.Free;
    Clipboard.Close;
  end;
  Application.MessageBox(PChar(FileName+' is saved!'), nil, MB_OK or MB_ICONINFORMATION);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  SaveFile('Rich Text Format', 'Clipboard.rtf');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  SaveFile('HTML Format', 'Clipboard.html');
end;

end.
